
struct symbol_struct {
	char *name;
	int type;
	int input_value;
	int output_default;
	int output_value;
	int lineno;
	struct output_struct *outputs;
	struct next_state_struct *next_state;
	struct symbol_struct *next;
};

struct output_struct {
	struct symbol_struct *sym;
	int value;
	struct output_struct *next;
};

struct cond_struct {
	struct symbol_struct *sym;
	int value;
	struct cond_struct *next;
};

struct next_state_struct {
	struct symbol_struct *sym;
	struct symbol_struct *next_state;
	struct cond_struct *cond;
	struct next_state_struct *next;
};


#define TYPE_INPUT -1000
#define TYPE_OUTPUT -1001
#define TYPE_STATE -1002

extern FILE *yyin;
extern char *yytext;
extern int lineno;
extern int err_count;
extern char lex_sym_name[];


extern int yyparse();
extern int yylex();
extern struct symbol_struct * add_symbol(char *name, int type, int default_output);
extern struct symbol_struct * lookup_symbol(const char *name);
extern void add_output(struct symbol_struct *state, const char *name, int value);
extern void add_next_state(struct symbol_struct *state, 
        const char *next_state_name, struct cond_struct *conditions);

